package com.huimv.modular.stockplan.result;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 年目标出栏量结果
 * </p>
 *
 * @author yinhao
 * @date 2021/8/24 16:33
 * @version 1.0
 */
@Data
public class StockPlanResult implements Serializable {
    private static final long serialVersionUID = -7584006357683868317L;

    /**
     * 主键
     */
    private Long id;

    /**
     * 年份
     */
    @Excel(name = "年份")
    private Integer year;

    /**
     * 目标出栏量
     */
    @Excel(name = "目标出栏量")
    private Integer targetOut;

    /**
     * 组织id
     */
    @Excel(name = "组织id")
    private Long orgId;

    /**
     * 父组织id
     */
    private Long parentOrgId;

    /**
     * 组织名称
     */
    private String orgName;



}
