package com.huimv.modular.timer.tasks;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.huimv.modular.alarmrecord.entity.AlarmRecord;
import com.huimv.modular.alarmrecord.service.AlarmRecordService;
import com.huimv.modular.alarmvalueset.entity.AlarmValueSet;
import com.huimv.modular.alarmvalueset.mapper.AlarmValueSetMapper;
import com.huimv.modular.collectorregister.mapper.CollectorRegisterMapper;
import com.huimv.modular.eartagdata.entity.EartagData;
import com.huimv.modular.eartagdata.mapper.EartagDataMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@Slf4j
@Component
public class ProduceAlarmRecor {

    @Autowired
    private EartagDataMapper eartagDataMapper   ;


    @Autowired
    private AlarmValueSetMapper alarmValueSetMapper    ;

    @Autowired
    private CollectorRegisterMapper collectorRegisterMapper    ;


    @Autowired
    private AlarmRecordService alarmRecordService     ;


    //生成报警记录
  //  @Scheduled(cron = " 0 */2 * * * ?")
    public void  checkDeviceAble() {
       //制造120S之前的时间
        //end
        System.out.println("生成警告");
        Date now = new Date();

        //设定时间之前
        Date   settingTimesBefore =  new Date(now.getTime() - 12000);//start
        System.out.println(now + "shijian" +settingTimesBefore );


        LambdaQueryWrapper<EartagData> wrapper11 = new LambdaQueryWrapper();
        wrapper11.between(EartagData::getTime,settingTimesBefore, now);
        List<EartagData> eartagDataList = eartagDataMapper.selectList(wrapper11);
        //将最近两分钟内的数据进行报警
        System.out.println(eartagDataList);


        for (EartagData eartagData : eartagDataList) {
            LambdaQueryWrapper<AlarmValueSet> wrapper112 = new LambdaQueryWrapper();
            wrapper112.eq(AlarmValueSet::getOrgId,eartagData.getOrgId());
            List<AlarmValueSet> alarmValueSets = alarmValueSetMapper.selectList(wrapper112);
            Map<Integer ,Double>  vale  = new HashMap();
            vale.put(1,null);
            vale.put(2,null);
            vale.put(3,null);
            vale.put(4,null);
            vale.put(5,null);
            vale.put(6,null);

            for (AlarmValueSet alarmValueSet : alarmValueSets) {
                if (vale.containsKey(alarmValueSet.getAlarmType())){
                    vale.put(alarmValueSet.getAlarmType(),alarmValueSet.getSetValue());
                }
            }



         if(eartagData.getEarTemp()> vale.get(1) ){


             AlarmRecord alarmRecord = new AlarmRecord();
             alarmRecord.setAlarmTime(new Date());
             alarmRecord.setEartagNo(eartagData.getEartagNo());
             alarmRecord.setCollectorCode(eartagData.getDeviceCode());
             alarmRecord.setNowValue(eartagData.getEarTemp());
             alarmRecord.setFarmCode(eartagData.getFarmCode( ));
             alarmRecord.setAlarmType(1);
             alarmRecord.setOrgId(eartagData.getOrgId());
             alarmRecord.setPenId(Integer.parseInt(eartagData.getPigpen()));
             alarmRecord.setRemark("ceshi");
             alarmRecordService.save(alarmRecord);

         }


            if(eartagData.getEarTemp()<vale.get(2) ){
                AlarmRecord alarmRecord = new AlarmRecord();
                alarmRecord.setAlarmTime(new Date());
                alarmRecord.setEartagNo(eartagData.getEartagNo());
                alarmRecord.setCollectorCode(eartagData.getDeviceCode());
                alarmRecord.setNowValue(eartagData.getEarTemp());
                alarmRecord.setFarmCode(eartagData.getFarmCode( ));
                alarmRecord.setAlarmType(2);
                alarmRecord.setOrgId(eartagData.getOrgId());
                alarmRecord.setPenId(Integer.parseInt(eartagData.getPigpen()));
                alarmRecord.setRemark("ceshi");
                alarmRecordService.save(alarmRecord);
            }


            if(eartagData.getEarTemp()> vale.get(3) ){
                AlarmRecord alarmRecord = new AlarmRecord();
                alarmRecord.setAlarmTime(new Date());
                alarmRecord.setEartagNo(eartagData.getEartagNo());
                alarmRecord.setCollectorCode(eartagData.getDeviceCode());
                alarmRecord.setNowValue(eartagData.getEarTemp());
                alarmRecord.setFarmCode(eartagData.getFarmCode( ));
                alarmRecord.setAlarmType(3);
                alarmRecord.setOrgId(eartagData.getOrgId());
                alarmRecord.setPenId(Integer.parseInt(eartagData.getPigpen()));
                alarmRecord.setRemark("ceshi");
                alarmRecordService.save(alarmRecord);
            }



            if(eartagData.getEarTemp()> vale.get(4) ){
                AlarmRecord alarmRecord = new AlarmRecord();
                alarmRecord.setAlarmTime(new Date());
                alarmRecord.setEartagNo(eartagData.getEartagNo());
                alarmRecord.setCollectorCode(eartagData.getDeviceCode());
                alarmRecord.setNowValue(eartagData.getEarTemp());
                alarmRecord.setFarmCode(eartagData.getFarmCode( ));
                alarmRecord.setAlarmType(4);
                alarmRecord.setOrgId(eartagData.getOrgId());
                alarmRecord.setPenId(Integer.parseInt(eartagData.getPigpen()));
                alarmRecord.setRemark("ceshi");
                alarmRecordService.save(alarmRecord);
            }

            if(eartagData.getEarTemp()> vale.get(1) ){
                AlarmRecord alarmRecord = new AlarmRecord();
                alarmRecord.setAlarmTime(new Date());
                alarmRecord.setEartagNo(eartagData.getEartagNo());
                alarmRecord.setCollectorCode(eartagData.getDeviceCode());
                alarmRecord.setNowValue(eartagData.getEarTemp());
                alarmRecord.setFarmCode(eartagData.getFarmCode( ));
                alarmRecord.setAlarmType(1);
                alarmRecord.setOrgId(eartagData.getOrgId());
                alarmRecord.setPenId(Integer.parseInt(eartagData.getPigpen()));
                alarmRecord.setRemark("ceshi");
                alarmRecordService.save(alarmRecord);
            }
        }
    }

}
