package com.huimv.incubator;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.scheduling.annotation.EnableScheduling;


/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@EnableScheduling            //开启定时任务
@SpringBootApplication
public class HuimvSmartincubatorDataAcquisitionApplication {
    public static void main(String[] args) {
        SpringApplication.run(HuimvSmartincubatorDataAcquisitionApplication.class, args);
    }

    //运行在41服务器
    //端口8211
    //数据库在公司本地  192.168.1.7
    //监听端口：  8899

}


