package com.huimv.incubator.service.impl;

import com.huimv.incubator.entity.IncubatorRegisterEntity;
import com.huimv.incubator.mapper.IncubatorRegisterDao;
import com.huimv.incubator.service.IncubatorRegisterService;
import com.huimv.incubator.socket.eartagrecive.util.PageUtils;
import com.huimv.incubator.socket.eartagrecive.util.Query;
import org.springframework.stereotype.Service;
import java.util.Map;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-08-13 09:08:21
 */
@Service("incubatorRegisterService")
public class IncubatorRegisterServiceImpl extends ServiceImpl<IncubatorRegisterDao, IncubatorRegisterEntity> implements IncubatorRegisterService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<IncubatorRegisterEntity> page = this.page(
                new Query<IncubatorRegisterEntity>().getPage(params),
                new QueryWrapper<IncubatorRegisterEntity>()
        );

        return new PageUtils(page);
    }

}