package com.huimv.incubator.socket.eartagrecive.service.impl;

import com.huimv.incubator.entity.AgeStageTempEntity;
import com.huimv.incubator.entity.EnvTempValueEntity;
import com.huimv.incubator.entity.IncubatorDataEntity;
import com.huimv.incubator.entity.IncubatorRegisterEntity;
import com.huimv.incubator.mapper.AgeStageTempDao;
import com.huimv.incubator.mapper.IncubatorDataDao;
import com.huimv.incubator.mapper.IncubatorRegisterDao;
import com.huimv.incubator.service.EnvTempValueService;
import com.huimv.incubator.service.IncubatorDataService;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;

import com.huimv.incubator.service.IncubatorRegisterService;
import com.huimv.incubator.socket.eartagrecive.util.DateUtilsPublic;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Date;

;

/**
 * @Project : huimv.ql
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Slf4j
@Component
public class ReceivePackageSerivce {

    @Autowired
    private IncubatorDataService incubatorDataService;

    @Autowired
    private EnvTempValueService envTempValueService ;

    @Autowired
    private AgeStageTempDao ageStageTempDao  ;

    @Autowired
    private IncubatorDataDao incubatorDataDao   ;


    @Autowired
    private IncubatorRegisterDao  incubatorRegisterDao     ;

    @Autowired
    private IncubatorRegisterService incubatorRegisterService     ;




    public String handleEartagDampness(String[] clientMessageArray) throws ParseException {


        //hm+9599+87021538+5+278+0+100+20210811172918+0+end

        String header = clientMessageArray[0];//hm
        String deviceId = clientMessageArray[1];//9599
        String cmd = clientMessageArray[3];//5
        String node_code = clientMessageArray[2];//87021538
        String temp_value = clientMessageArray[4];//278
        String night_rank = clientMessageArray[5];//0 暖光登记
        String now_age = clientMessageArray[6];//当前日龄
        String time = clientMessageArray[7]; //shijian 20210811172918
        String checkCode = clientMessageArray[8]; //check
        String tail = clientMessageArray[9]; //tail
        IncubatorDataEntity incubatorDataEntity = new IncubatorDataEntity();

        incubatorDataEntity.setCheckCode(checkCode);
        incubatorDataEntity.setCmd(Integer.valueOf(cmd));
        incubatorDataEntity.setCreateTime(new Date());
        incubatorDataEntity.setDeviceCode(deviceId);
        incubatorDataEntity.setHead(header);
        incubatorDataEntity.setNowAge(Integer.valueOf(now_age));
        incubatorDataEntity.setNightRank(Integer.valueOf(night_rank));
        incubatorDataEntity.setNodeCode(node_code);
        incubatorDataEntity.setRemark("ceshi");
        incubatorDataEntity.setTempValue(Double.valueOf(temp_value)/10);
        incubatorDataEntity.setTail(tail);
/*
       //开始加判断。日期转换日龄+1
        LambdaQueryWrapper<IncubatorDataEntity> wrapper11 = Wrappers.lambdaQuery();
        //小于
        wrapper11.eq(IncubatorDataEntity::getNodeCode,node_code).orderByAsc( IncubatorDataEntity::getId ).last( "limit 1");
        IncubatorDataEntity incubatorDataEntity1 = incubatorDataDao.selectOne(wrapper11);
        Boolean  daySame= DateUtilsPublic.dayIsSame(incubatorDataEntity1.getCreateTime(),new Date() );


        if( !daySame ) {
            //不相同  日龄+1
            LambdaQueryWrapper<IncubatorRegisterEntity> wrapper13 = Wrappers.lambdaQuery();
            wrapper13.eq(IncubatorRegisterEntity::getNodeCode, node_code).orderByAsc(IncubatorRegisterEntity::getId).last("limit 1");
            IncubatorRegisterEntity incubatorRegisterEntity = incubatorRegisterDao.selectOne(wrapper13);
            incubatorRegisterEntity.setAge(incubatorRegisterEntity.getAge() + 1);
            incubatorRegisterService.updateById(incubatorRegisterEntity);
        }*/

        incubatorDataService.save(incubatorDataEntity);


       // hm+9599+87021538+5+262+0+0+20210825093650+0+end


   //返回的数据做文章--温度的设置---查对应日龄的温度  100---用第一条来计算温度.修改的就是第一条温度
        //日龄应该是查对应的表给对应的温度
        //大于
      /*  LambdaQueryWrapper<AgeStageTempEntity> wrapper1 = Wrappers.lambdaQuery();
        //小于
        wrapper1.le(AgeStageTempEntity::getAge,now_age).orderByAsc( AgeStageTempEntity::getId ).last( "limit 1");
        System.out.println(now_age);
        AgeStageTempEntity ageStageTempEntity = ageStageTempDao.selectOne(wrapper1);

        System.out.println(ageStageTempEntity);
        Integer a = (int) (ageStageTempEntity.getTemp()*10);*/
         //日龄应该是我给机器的啊，需要维护一张表---生日--对应参数
      //  System.out.println("五号命令返回+"+"hm+5+"+node_code+"+0+5+"+a+"+6+end" );
        return  "hm+5+"+node_code+"+0+5+"+455+"+6+end";

    }



    /**
     * @Method : _handleEartagTemperature
     * @Description : 处理网关温度
     * @Params : [clientMessageArray]
     * @Return : java.lang.String
     * @Author : ZhuoNing
     * @Date : 2021/1/15
     * @Time : 17:46
     */
    public String handleEartagTemperature(String[] clientMessageArray) throws ParseException {
        System.out.println("环境温度上传");

        String header = clientMessageArray[0];
        String device_code = clientMessageArray[1];
        String cmd = clientMessageArray[2];
        String serialNo = clientMessageArray[3];
        String temp_value = clientMessageArray[4];
        String timestamp = clientMessageArray[5];
        String checkCode = clientMessageArray[6];
        String tail = clientMessageArray[7];

     //hm+158+3+1+289+20170208152300+6+end
        EnvTempValueEntity envTempValueEntity = new EnvTempValueEntity();
        envTempValueEntity.setCmd(Integer.valueOf(cmd));
        envTempValueEntity.setChexk(checkCode);
        envTempValueEntity.setHead(header);
        envTempValueEntity.setDeviceCode(device_code);
        envTempValueEntity.setCreateTime(new Date());
        envTempValueEntity.setRemark("环境温度");
        envTempValueEntity.setValue(String.valueOf(Double.valueOf(temp_value)/10));
        envTempValueEntity.setSerious(serialNo);
        envTempValueEntity.setTail(tail);
        envTempValueService.save(envTempValueEntity);
    return "hm+4+0+7+end";
    }


    public static void main(String[] args) {
        DecimalFormat df = new DecimalFormat("####0.00");
        System.out.println(df.format(23.00000));
    }

    public static  double getTwoDecimal(double num) {
        DecimalFormat   dFormat = new DecimalFormat("#.00");
        String yearString = dFormat.format(num);
        return  Double.parseDouble(yearString);

    }

    public static  double  m1(double num ) {
        BigDecimal bg = new BigDecimal(num);
        return  bg.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
    }

    public static String swapHex(String src) {
        StringBuilder target = new StringBuilder();
        for (int i = src.length() - 1; i > 0; i -= 2) {
            target.append(src.substring(i - 1, i + 1));
        }
        return target.toString();
    }
    public static String numberFormater(double d) {
        DecimalFormat nf = new DecimalFormat();
        nf.setMaximumFractionDigits(2);
        return nf.format(d);
    }
    public static double A = 0.00335396319311466;
    public static double B = 0.000256376549039663;
    public static double C = 0.00000248933580817244;
    public static double D = 0.0000000753805242068686;
    public static double E = -0.0000000204758173596178;

    //保留一位小数
    public static double changeDouble(Double dou) {
        NumberFormat nf = new DecimalFormat("0.0 ");
        dou = Double.parseDouble(nf.format(dou));
        return dou;
    }



    //温度转换
    public static double ln(int rv) {
        int R_REF = 10000;
        double ln = Math.log((double) rv / R_REF);
        //保留一位小数
        return changeDouble(1 / (A + B * ln + C * Math.pow(ln, 2) + D * Math.pow(ln, 3) + E * Math.pow(ln, 4)) - 273.15)+0.001;
    }

}
